/******************************************************************************
  (c) Copyright 2002-2008, 1060 Research Ltd                                   

  This Software is licensed to You, the licensee, for use under the terms of   
  the 1060 Public License v1.0. Please read and agree to the 1060 Public       
  License v1.0 [www.1060research.com/license] before using or redistributing   
  this software.                                                               

  In summary the 1060 Public license has the following conditions.             
  A. You may use the Software free of charge provided you agree to the terms   
  laid out in the 1060 Public License v1.0                                     
  B. You are only permitted to use the Software with components or applications
  that provide you with OSI Certified Open Source Code [www.opensource.org], or
  for which licensing has been approved by 1060 Research Limited.              
  You may write your own software for execution by this Software provided any  
  distribution of your software with this Software complies with terms set out 
  in section 2 of the 1060 Public License v1.0                                 
  C. You may redistribute the Software provided you comply with the terms of   
  the 1060 Public License v1.0 and that no warranty is implied or given.       
  D. If you find you are unable to comply with this license you may seek to    
  obtain an alternative license from 1060 Research Limited by contacting       
  license@1060research.com or by visiting www.1060research.com                 

  NO WARRANTY:  THIS SOFTWARE IS NOT COVERED BY ANY WARRANTY. SEE 1060 PUBLIC  
  LICENSE V1.0 FOR DETAILS                                                     

  THIS COPYRIGHT NOTICE IS *NOT* THE 1060 PUBLIC LICENSE v1.0. PLEASE READ     
  THE DISTRIBUTED 1060_Public_License.txt OR www.1060research.com/license      
 *****************************************************************************/
package org.netkernel.container.impl;

import org.netkernel.container.ITimer;

public class TimerImpl
{
	private static ITimer sInstance = new SystemCurrentTimeMillisTimer();
	
	/** This may want to get more sophisticated to provide configuration of timer type
	 * or selection on a per platform basis
	 * @return
	 */
	public static ITimer getInstance()
	{	return sInstance;
	}
	
	private static class SystemCurrentTimeMillisTimer implements ITimer
	{
		private volatile long mTime;
		
		public long getRelativeTime()
		{	long t=System.nanoTime()/1000;
			return t;
		}

		public long getRelativeTimeDivisor()
		{	return 1000;
		}
		
		public long getAbsoluteTime()
		{	mTime=System.currentTimeMillis();
			return mTime;
		}

		public long getApproximateTime()
		{	return mTime;
		}

	}
	
	//mTime=sThreadMXBean.getCurrentThreadCpuTime();
	//mTime=System.nanoTime();
	
	/*
	static
	{	sThreadMXBean = ManagementFactory.getThreadMXBean();
		//System.out.println(mxbean.isThreadCpuTimeSupported()+" "+mxbean.isThreadCpuTimeEnabled());
	}
	private static ThreadMXBean sThreadMXBean;
	*/	
	
	//linux HP6710b jdk1.5.0_16
	//1160ns for a System.currentTimeMillis();
	//1160ns for a System.nanoTime();
	//2ns for loop
	//80ns for r.freeMemory();
	//80ns for r.maxMemory();
	//80ns for r.totalMemory();
	//20947ns for ThreadMXBean.getCurrentThreadCpuTime()
	//20947ns for ThreadMXBean.getCurrentThreadUserTime()
	//20ns for method invoke for long;
	//20ns for AtomicLong.get()
	//28ns for AtomicLong.getAndIncrement()
	// 900ns MemoryMXBean.getHeapMemoryUsage().getUsed();

	//linux HP6710b open-jdk1.6
	//1000ns for a System.currentTimeMillis();
   //1000ns for a System.nanoTime();
   //10ns for loop
   //74ns for r.freeMemory();
   //74ns for r.maxMemory();
   //74ns for r.totalMemory();
   //20947ns for ThreadMXBean.getCurrentThreadCpuTime()
   //20947ns for ThreadMXBean.getCurrentThreadUserTime() 	
	//20ns for method invoke for long;
	//20ns for AtomicLong.get()
	//28ns for AtomicLong.getAndIncrement()
	
	//windows inspiron 6000 -jdk1.5.0_04
	  //75ns for a System.currentTimeMillis();
	  //1898ns for a System.nanoTime();
	  //8ns for loop
	  //117ns for r.totalMemory();
	  //934ns for ThreadMXBean.getCurrentThreadUserTime()
	  //985ns for ThreadMXBean.getCurrentThreadCpuTime()
	  //23ns for AtomicLong.get()
	  //40ns for AtomicLong.getAndIncrement()
	  //13ns for function to return static long;	
	
}
